include masm32rt.inc
.686p
.mmx
.xmm

WndProc1 proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
WndProc2 proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

.data?
	hInstance	HINSTANCE	?
	hWndActiv	HWND		?
	hWnd1		HWND		?
	hWnd2		HWND		?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,0
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class1")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov hWnd1,rv(CreateWindowEx,0,wcex.lpszClassName,"Window 1",WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)
	mov hWnd2,rv(CreateWindowEx,0,wcex.lpszClassName,"Window 2",WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	; initalize state-variable
	m2m hWndActiv,hWnd1
	
	; show the windows according to their state
	invoke ShowWindow,hWnd1,SW_SHOW
	invoke ShowWindow,hWnd2,SW_SHOWNA
	
	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_ACTIVATE
		
		; force activ window if needed
		movzx esi,WORD ptr wParam
		mov ebx,hWndActiv
		.if (esi&WA_ACTIVE || esi&WA_CLICKACTIVE) && ebx != hWnd
			invoke SetActiveWindow,hWndActiv
		.elseif 
		.endif
	.elseif uMsg == WM_KEYDOWN
		.if wParam == VK_W
			mov ebx,hWndActiv
			.if ebx == hWnd1
				m2m hWndActiv,hWnd2
			.else
				m2m hWndActiv,hWnd1
			.endif
			invoke SetActiveWindow,hWndActiv
		.endif
	.elseif uMsg == WM_PAINT
		mov esi,rv(BeginPaint,hWnd,ADDR ps)
		fn TextOut,esi,0,0,"press W-key for switching",25
		invoke EndPaint,hWnd,ADDR ps
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
